%ifarch ppc ppc64
%define __arch		ppc
%else
%define __arch		x86_64
%endif
%define __version       00
%define __release	00.02
%define __osxver	10.15
%define __vername	00-00-02

Summary: A persistency layer for LCIO 
Name: SIO
Version: %{__version}.%{__release}
Release: %{__osxver}%{?dist}1a
Source0: localhost:/%{name}-%{__vername}.tar.gz
Patch0:  localhost:/SIO-00-00-02-macosx10.14.patch
URL: https://github.com/iLCSoft/SIO
Group: Development/Libraries
License: Linear Collider Study Group
%define __prefix	/opt/sio
Prefix: %{__prefix}
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: root

%description
SIO is a persistency solution for reading and writing binary data in SIO 
structures called record and block. SIO has originally been implemented 
as persistency layer for LCIO.

%prep
%setup -q -n SIO-%{__vername}
%ifos darwin
%patch0 -p1 -b .osx
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'`

%build
mkdir build
cd build
cmake -DCMAKE_INSTALL_PREFIX=%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'` -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++ ..
make %{?_smp_mflags}

# fix paths to config files
mv SIOConfig.cmake SIOConfig.cmake.orig
sed -e 's;\(.*\)/Users/.*/SIO-\([0-9]*\)-\([0-9]*\)-\([0-9]*\)\(.*\);\1/opt/sio/v\2-\3-\4\5;' SIOConfig.cmake.orig > SIOConfig.cmake
mv SIOConfigVersion.cmake SIOConfigVersion.cmake.orig
sed -e 's;\(.*\)/Users/.*/SIO-\([0-9]*\)-\([0-9]*\)-\([0-9]*\)\(.*\);\1/opt/sio/v\2-\3-\4\5;' SIOConfigVersion.cmake.orig > SIOConfigVersion.cmake

make install DESTDIR=$RPM_BUILD_ROOT


%install
cd %{_builddir}/SIO-%{__vername}
cp -RPp cmake $RPM_BUILD_ROOT%{prefix}/`echo v%{version} | sed -e 's;\.;-;g'`

find $RPM_BUILD_ROOT -type d | sed -e "s;$RPM_BUILD_ROOT;%dir ;" \
			     | grep -ve '^%dir %{prefix}$' \
			     | grep -ve '^%dir /[^/]*$'  \
			     | grep -ve '^%dir $' >> list.f
find $RPM_BUILD_ROOT -type f | sed -e "s;$RPM_BUILD_ROOT;;" >> list.f
find $RPM_BUILD_ROOT -type l | sed -e "s;$RPM_BUILD_ROOT;;" >> list.f

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{_builddir}/SIO-%{__vername}/list.f
%defattr(-,root,wheel)

%changelog
* Wed Jan 29 2020 Keisuke Fujii <keisuke.fujii@kek.jp> 00-00-02-10.15hepx1a
- 1st build and release on MacOS X 10.15 for Intel Macs
- built with OSXWS 10.15

* Fri Jan 3 2020 Keisuke Fujii <keisuke.fujii@kek.jp> 00-00-02-10.14hepx1a
- 1st build and release on MacOS X 10.14 for Intel Macs
- built with OSXWS 10.14
